Option Strict On

Public Class MySldWorksCls

    Dim oSwAppCls As SldWorks.SldWorks

    Friend ReadOnly Property MySldWorks() _
                    As SldWorks.SldWorks
        Get
            Return oSwAppCls
        End Get
    End Property

    Friend Function SolidWorksInstanzCreate() _
                        As SldWorks.SldWorks
        Try
            'SolidWorks Objekt initialisieren
            oSwAppCls = CType(Microsoft.VisualBasic.CreateObject( _
                  ProgId:="SldWorks.Application"), SldWorks.SldWorks)
            Return oSwAppCls
        Catch ex As Exception
            Debug.Assert(False)
            MsgBox("Fehler: Wo: " & _
                ex.StackTrace & " Was: " & ex.Message)
            Return Nothing
        End Try
    End Function

    Friend Sub VersionAnzeigen()
        Try
            'Rckgabewert der SolidWorks 
            'MessageBox
            Dim eSwMsgBox As SwConst.swMessageBoxResult_e
            'SolidWorks Fenster anzeigen
            oSwAppCls.Visible = True
            'SolidWorks Version
            'in einer MsgBox anzeigen
            eSwMsgBox = CType(oSwAppCls.SendMsgToUser2( _
                "SolidWorks Version: " & _
                Me.VersionInJahr, _
                SwConst.swMessageBoxIcon_e.swMbInformation, _
                SwConst.swMessageBoxBtn_e.swMbYesNo), _
                SwConst.swMessageBoxResult_e)
            Select Case eSwMsgBox
                Case SwConst.swMessageBoxResult_e.swMbHitYes
                    'Hinweis in einer MsgBox
                    MsgBox("Der User hat auf Ja geklickt")
                Case SwConst.swMessageBoxResult_e.swMbHitNo
                    'Hinweis in einer MsgBox
                    MsgBox("Der User hat auf Nein geklickt")
                Case Else
                    Debug.Assert(False)
            End Select

        Catch ex As Exception
            Debug.Assert(False)
            MsgBox("Fehler: Wo: " & _
                ex.StackTrace & " Was: " & ex.Message)
        End Try
    End Sub

    Friend Function SolidWorksInstanzGet() _
                      As SldWorks.SldWorks
        Try
            oSwAppCls = CType(Microsoft.VisualBasic.GetObject( _
                Class:="SldWorks.Application"), SldWorks.SldWorks)
            Return oSwAppCls
        Catch ex As Exception
            Debug.Assert(False)
            MsgBox("Fehler: Wo: " & _
                ex.StackTrace & " Was: " & ex.Message)
            Return Nothing
        End Try
    End Function

    ''' <summary>
    ''' Initialisiert das SolidWorks Objekt durch die Methode GetObject 
    ''' und fragt in einer MsgBox nach wenn das Objekt nicht greifbar ist. 
    ''' </summary>
    ''' <param name="bUserAbbruch">
    ''' Optionaler Rckgabewert, welcher mitteilt ob der User
    ''' die Aktion abgerochen hat oder ein Fehler aufgetreten ist.
    ''' </param>
    ''' <returns>Instanz der atkuellen SolidWorks Sitzung</returns>
    ''' <remarks></remarks>
    Public Function SolidWorksInstanz( _
            Optional ByRef bUserAbbruch As Boolean = False) _
            As SldWorks.SldWorks
        Try
            'Variable fr die MsgBox-Rckgabe
            Dim lDialogStatus As Microsoft.VisualBasic.MsgBoxResult
            Try
                'SolidWorks Objekt belegen
                oSwAppCls = CType(GetObject(, _
                    "SldWorks.Application"), _
                    SldWorks.SldWorks)
            Catch ex As Exception
            End Try
            'Wenn das SolidWorks Objekt nicht belegt ist...
            If oSwAppCls Is Nothing Then
                '... in einer MsgBox nachfragen
                lDialogStatus = MsgBox( _
                    "Fehler beim Aufbau einer Schnittstelle zu SolidWorks." & _
                    vbNewLine & _
                    "Bitte ffnen Sie SolidWorks und klicken Sie auf ""Ok""." & _
                    vbNewLine & _
                    "Sollte SolidWorks bereits geffnet sein, " & _
                    "schlieen Sie SolidWorks, " & _
                    vbNewLine & _
                    "ffnen Sie es erneut und klicken Sie dann auf ""Ok""." & _
                    vbNewLine & _
                    "Wenn Sie denn Startvorgang abbrechen " & _
                    "mchten klicken Sie auf ""Abbrechen"".", _
                    MsgBoxStyle.Information Or MsgBoxStyle.OkCancel, _
                    "Schuler Design Automation GmbH")
                'Rckgabewert der MsgBox auswerten
                Select Case lDialogStatus
                    Case MsgBoxResult.Ok
                        'User hat SolidWorks geffnet
                        'Funktion einfach nochmal ausfhren
                        Return SolidWorksInstanz(bUserAbbruch)
                    Case MsgBoxResult.Cancel
                        'User mchte die Anwednung abbrechen
                        bUserAbbruch = True
                        Return Nothing
                End Select
            End If
            Return oSwAppCls
        Catch ex As Exception
            Debug.Assert(False)
            MsgBox("Fehler: Wo: " & _
                ex.StackTrace & " Was: " & ex.Message)
            Return Nothing
        End Try
    End Function

    Friend ReadOnly Property VersionInJahr() As Integer
        Get
            Dim iHauptversion As Integer
            Dim sVersionen() As String
            'SolidWorks Instanz prfen
            If oSwAppCls Is Nothing Then
                '-1 als ungltige Rckgabe verwenden
                Return -1
            Else
                'Version ermitteln und an den
                'Trennpunkten teilen
                sVersionen = _
                    oSwAppCls.RevisionNumber.Split( _
                    CChar("."))
                'Nur die Hauptversion weiter verwenden
                iHauptversion = CInt(sVersionen(0))
                'Version in Jahreszahl umrechnen
                iHauptversion = iHauptversion + 1992
                'Die Hauptversion in Jahren 
                'als Rckgabe verwenden
                Return iHauptversion
            End If
        End Get
    End Property

End Class
